#<profile4xi profile = "31"/>
#<program4xi program = "shoot2dragon4uri5test.py">
#<abstract4xi abstract = "test shoot2dragon4uri which is used by automate2ref4uri"/>
#<refer4xi reference = "automate2ref4uri.py"/>
#<note4xi note = "it's wise to test a dragon function before generating it to be used as a target function for processes"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
#<use4xi usage = "
#
# 1) go to Studio4Xi in commmand mode
#     > go3studio4fb    <-- Python 3 version of Studio4Xi in Fastblack workstation (fb)
#     > go3studio4riika <-- Python 3 version of Studio4Xi in Riika
#     nb: you could use the same go2studio4xi-command in all workstations just defining root! 
#
# 2) edit version4xi.py
#
#      # ===========================================================================================================                         
#      # automate2ref4uri.py
#      # ===========================================================================================================                          
#      'master2ref4uri':   'J://temp//yosense//test2master//',         # [ACK] Sun       (master used by shoot2dragon4uri5test.py only) 
#      'dragon2ref4uri':   'F://temp//yosense//test2dragon//',         # [ACK] Saturn    (base for 1 ... 33)
#      
#      #dynamic-start
#      'zero2ref4uri':     'D://temp//yosense//test2zero//',           # [ACK] Eris      
#      'one2ref4uri':      'G://temp//yosense//test2one//',            # [ACK] Titan     
#      'two2ref4uri':      'H://temp//yosense//test2two//',            # [ACK] Enceladus 
#      'three2ref4uri':    'I://temp//yosense//test2three//',          # [ACK] Phoebe    
#      'four2ref4uri':     'K://temp//yosense//test2four//',           # [ACK] Theia     
#      'five2ref4uri':     'L://temp//yosense//test2five//',           # [ACK] Haumea    
#      'six2ref4uri':      'M://temp//yosense//test2six//',            # [ACK] Logic     
#      'seven2ref4uri':    'N://temp//yosense//test2seven//',          # [ACK] Venus     
#      'eight2ref4uri':    'O://temp//yosense//test2eight//',          # [ACK] Jupiter  
#      'nine2ref4uri':     'P://temp//yosense//test2nine//',           # [ACK] Kelvin   
#      'ten2ref4uri':      'Q://temp//yosense//test2ten//',            # [ACK] Taiko   
#      'eleven2ref4uri':   'F://temp//yosense//test2eleven//',         # [ACK] Saturn   
#      'twelve2ref4uri':   'G://temp//yosense//test2twelve//',         # [ACK] Titan    
#      'thirteen2ref4uri': 'M://temp//yosense//test2thirteen//',       # [ACK] Logic   
#      'fourteen2ref4uri': 'K://temp//yosense//test2fourteen//',       # [ACK] Theia   
#      'fifteen2ref4uri':  'L://temp//yosense//test2fifteen//',        # [ACK] Haumea  
#      'sixteen2ref4uri':  'M://temp//yosense//test2sixteen//',        # [ACK] Logic   
#      'seventeen2ref4uri':'N://temp//yosense//test2seventeen//',      # [ACK] Venus   
#      'eighteen2ref4uri': 'O://temp//yosense//test2eighteen//',       # [ACK] Jupiter 
#      'nineteen2ref4uri': 'P://temp//yosense//test2nineteen//',       # [ACK] Kelvin  
#      
#      'twenty2ref4uri':      'Q://temp//yosense//test2twenty//',      # [ACK] Taiko   
#      'twentyone2ref4uri':   'F://temp//yosense//test2twentyone//',   # [ACK] Saturn  
#      'twentytwo2ref4uri':   'G://temp//yosense//test2twentytwo//',   # [ACK] Titan   
#      'twentythree2ref4uri': 'I://temp//yosense//test2twentythree//', # [ACK] Phoebe  
#      'twentyfour2ref4uri':  'K://temp//yosense//test2twentyfour//',  # [ACK] Theia   
#      'twentyfive2ref4uri':  'L://temp//yosense//test2twentyfive//',  # [ACK] Haumea 
#      'twentysix2ref4uri':   'M://temp//yosense//test2twentysix//',   # [ACK] Logic  
#      'twentyseven2ref4uri': 'N://temp//yosense//test2twentyseven//', # [ACK] Venus  
#      'twentyeight2ref4uri': 'O://temp//yosense//test2twentyeight//', # [ACK] Jupiter
#      'twentynine2ref4uri':  'P://temp//yosense//test2twentynine//',  # [ACK] Kelvin  
#      
#      'thirty2ref4uri':      'Q://temp//yosense//test2thirty//',      # [ACK] Taiko  
#      'thirtyone2ref4uri':   'F://temp//yosense//test2thirtyone//',   # [ACK] Saturn 
#      'thirtytwo2ref4uri':   'G://temp//yosense//test2thirtytwo//',   # [ACK] Titan  
#      'thirtythree2ref4uri': 'M://temp//yosense//test2thirtythree//', # [ACK] Logic  
#      #dynamic-end
#                                               
# 3) > shoot2dragon4uri5test
#
# 4) view trace
#      \temp\shoot2dragon4uri5test.txt <-- check for any erros, if necessary and see statistics
#      \web\xmlace-shoot2dragon4uri5test.xml
#      \web\reason-shoot2dragon4uri5test.xml
#      \web\sense-shoot2dragon4uri5test.xml
#
#    analyze each run such as testing hyperlinks to cam,medium and large images: 
#    a) check <b>&Sigma;</b>[URL]: <-- 2 [NACK] *** <-- correct 
#    b) check TOTAL STATISTICS; also use FTP to upload if necessary or delete extra ones in your hard disk
#    c) run again shoot2dragon4uri5test
#    d) check with file explorer *2?4yo.html dates to make sure you have run build2hyperlink4content.py
#    nb: although the HTML files to be tested have been created by build2hyperlink4content.py the URL links
#        may be faulty if images have been deleted in server
#      
# 5) test hyperlinks
# 
# 6) test hyperlinks locally and correct & rerun, if necessary
#    file:///E:/DRAGONXI/PC4Xi/YoDragonXiOrg/WebSite/sense/index-sense-xi2.html
#
# 7) copy and ftp upload to server corrected HTML files
#    E:\DRAGONXI\PC4Xi\YoDragonXiOrg\WebSite\sense
#
# 8) test with browser web content (password protected)
#    https://www.yourdragonxi.org/sense/index-sense-xi2.html
#
# TIPS:
#    Python web libraries are NOT reliable, for example
#    HTML files such as year,alpha having lot of hyperlinks in one file may produce faulty error messages
#    claiming image referred is not in server although it does exist there!
#    therefore you have to check manually with browser and FTP-client!
#"
#/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2dragon4uri5test.py' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                           
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os,sys,string

import threading                
import _thread
import _winapi 

import signal
import itertools
import weakref
import logging 

#"
#/>

# -------------------------------------------------------------------------------------------------
# Studio4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi 
from version4xi import ROOT4XI
#dynamic-start
from generate2gun4uri import generate2gun4uri
from generate2shoot4uri import generate2shoot4uri
#dynamic-end
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Multiprocessing4xi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from actor2a4xi import Actor2a4Xi                                                                                  
from actor2b4xi import Actor2b4Xi                                                                                   
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi

# -------------------------------
# dragon
# -------------------------------
from gun2dragon4uri import gun2dragon4uri

#dynamic-start
# import can be done only after the function has been generated
#dynamic-end

from current_process4xi import get_current_process4xi            
from current_process4xi import get_identity_current_process4xi
from current_process4xi import get_name_current_process4xi

from dummyprocess4xi import DummyProcess4Xi

from pickle4xi import pickle4xi                                                                                   
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
from pipe4xi import Pipe4Xi   
from print4xi import Print4Xi 


from print4xi import print4xi
from print4xi import set_print_permission4xi
from process4xi import Process4Xi

from queue4xi import Queue4Xi

from sleep4xi import omega2sleep4xi

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global ack2message4index

global ack4queues
global nack4queues

global ack4pipes
global nack4pipes

global ack4process
global nack4process

global ack4start
global nack4start   
        
global ack4run
global nack4run

#dynamic-start
global DirectionKB4Xi
global keys2DirectionKB4Xi
global key2DirectionKB4Xi
#dynamic-end

global DomainKB4Xi
global keys2DomainKB4Xi
global key2DomainKB4Xi

global master2ref4uri 
global dragon2ref4uri

#dynamic-start 
global zero2ref4uri                          
global one2ref4uri
global two2ref4uri
global three2ref4uri
global four2ref4uri
global five2ref4uri
global six2ref4uri
global seven2ref4uri
global eight2ref4uri
global nine2ref4uri
global ten2ref4uri
global eleven2ref4uri
global twelve2ref4uri
global thirteen2ref4uri
global fourteen2ref4uri
global fifteen2ref4uri
global sixteen2ref4uri
global seventeen2ref4uri
global eighteen2ref4uri
global nineteen2ref4uri
global twenty2ref4uri
global twentyone2ref4uri
global twentytwo2ref4uri
global twentythree2ref4uri
global twentyfour2ref4uri
global twentyfive2ref4uri
global twentysix2ref4uri
global twentyseven2ref4uri
global twentyeight2ref4uri
global twentynine2ref4uri
global thirty2ref4uri
global thirtyone2ref4uri
global thirtytwo2ref4uri
global thirtythree2ref4uri
#dynamic-end

global path2temp4xi                          # path for output files
global PickleKB4Xi

global NameKB4Xi
global keys2NameKB4Xi
global key2NameKB4Xi

global t2xi 
global trace_object_count 
#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings 
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2message4index = False

#dynamic-start
 
DirectionKB4Xi = {}

DirectionKB4Xi['zero']     = {}
DirectionKB4Xi['zero'] ['channel2publish']  = None
DirectionKB4Xi['zero'] ['channel2consume']  = None
DirectionKB4Xi['zero'] ['queue'] = None
DirectionKB4Xi['zero'] ['function2target']  = None
DirectionKB4Xi['zero'] ['number2process']   = None
DirectionKB4Xi['zero'] ['name2process']     = None
DirectionKB4Xi['zero'] ['status2process']   = None
DirectionKB4Xi['zero'] ['cc2put']           = "<copy4xi>copy2zero</copy4xi>"
DirectionKB4Xi['zero'] ['cc2send']          = "<copy4xi>copy2zero</copy4xi>"
DirectionKB4Xi['zero'] ['cc2get']           = "<roger4xi>roger2zero</roger4xi>"
DirectionKB4Xi['zero'] ['cc2receive']       = "<roger4xi>roger2zero</roger4xi>"
DirectionKB4Xi['zero'] ['path2analyse']     = VersionKB4Xi['zero2ref4uri']

DirectionKB4Xi['one']     = {}
DirectionKB4Xi['one'] ['channel2publish']  = None
DirectionKB4Xi['one'] ['channel2consume']  = None
DirectionKB4Xi['one'] ['queue'] = None
DirectionKB4Xi['one'] ['function2target']  = None
DirectionKB4Xi['one'] ['number2process']   = None
DirectionKB4Xi['one'] ['name2process']     = None
DirectionKB4Xi['one'] ['status2process']   = None
DirectionKB4Xi['one'] ['cc2put']           = "<copy4xi>copy2one</copy4xi>"
DirectionKB4Xi['one'] ['cc2send']          = "<copy4xi>copy2one</copy4xi>"
DirectionKB4Xi['one'] ['cc2get']           = "<roger4xi>roger2one</roger4xi>"
DirectionKB4Xi['one'] ['cc2receive']       = "<roger4xi>roger2one</roger4xi>"
DirectionKB4Xi['one'] ['path2analyse']     = VersionKB4Xi['one2ref4uri']

DirectionKB4Xi['two']     = {}
DirectionKB4Xi['two'] ['channel2publish']  = None
DirectionKB4Xi['two'] ['channel2consume']  = None
DirectionKB4Xi['two'] ['queue'] = None
DirectionKB4Xi['two'] ['function2target']  = None
DirectionKB4Xi['two'] ['number2process']   = None
DirectionKB4Xi['two'] ['name2process']     = None
DirectionKB4Xi['two'] ['status2process']   = None
DirectionKB4Xi['two'] ['cc2put']           = "<copy4xi>copy2two</copy4xi>"
DirectionKB4Xi['two'] ['cc2send']          = "<copy4xi>copy2two</copy4xi>"
DirectionKB4Xi['two'] ['cc2get']           = "<roger4xi>roger2two</roger4xi>"
DirectionKB4Xi['two'] ['cc2receive']       = "<roger4xi>roger2two</roger4xi>"
DirectionKB4Xi['two'] ['path2analyse']     = VersionKB4Xi['two2ref4uri']

DirectionKB4Xi['three']     = {}
DirectionKB4Xi['three'] ['channel2publish']  = None
DirectionKB4Xi['three'] ['channel2consume']  = None
DirectionKB4Xi['three'] ['queue'] = None
DirectionKB4Xi['three'] ['function2target']  = None
DirectionKB4Xi['three'] ['number2process']   = None
DirectionKB4Xi['three'] ['name2process']     = None
DirectionKB4Xi['three'] ['status2process']   = None
DirectionKB4Xi['three'] ['cc2put']           = "<copy4xi>copy2three</copy4xi>"
DirectionKB4Xi['three'] ['cc2send']          = "<copy4xi>copy2three</copy4xi>"
DirectionKB4Xi['three'] ['cc2get']           = "<roger4xi>roger2three</roger4xi>"
DirectionKB4Xi['three'] ['cc2receive']       = "<roger4xi>roger2three</roger4xi>"
DirectionKB4Xi['three'] ['path2analyse']     = VersionKB4Xi['three2ref4uri']

DirectionKB4Xi['four']     = {}
DirectionKB4Xi['four'] ['channel2publish']  = None
DirectionKB4Xi['four'] ['channel2consume']  = None
DirectionKB4Xi['four'] ['queue'] = None
DirectionKB4Xi['four'] ['function2target']  = None
DirectionKB4Xi['four'] ['number2process']   = None
DirectionKB4Xi['four'] ['name2process']     = None
DirectionKB4Xi['four'] ['status2process']   = None
DirectionKB4Xi['four'] ['cc2put']           = "<copy4xi>copy2four</copy4xi>"
DirectionKB4Xi['four'] ['cc2send']          = "<copy4xi>copy2four</copy4xi>"
DirectionKB4Xi['four'] ['cc2get']           = "<roger4xi>roger2four</roger4xi>"
DirectionKB4Xi['four'] ['cc2receive']       = "<roger4xi>roger2four</roger4xi>"
DirectionKB4Xi['four'] ['path2analyse']     = VersionKB4Xi['four2ref4uri']

DirectionKB4Xi['five']     = {}
DirectionKB4Xi['five'] ['channel2publish']  = None
DirectionKB4Xi['five'] ['channel2consume']  = None
DirectionKB4Xi['five'] ['queue'] = None
DirectionKB4Xi['five'] ['function2target']  = None
DirectionKB4Xi['five'] ['number2process']   = None
DirectionKB4Xi['five'] ['name2process']     = None
DirectionKB4Xi['five'] ['status2process']   = None
DirectionKB4Xi['five'] ['cc2put']           = "<copy4xi>copy2five</copy4xi>"
DirectionKB4Xi['five'] ['cc2send']          = "<copy4xi>copy2five</copy4xi>"
DirectionKB4Xi['five'] ['cc2get']           = "<roger4xi>roger2five</roger4xi>"
DirectionKB4Xi['five'] ['cc2receive']       = "<roger4xi>roger2five</roger4xi>"
DirectionKB4Xi['five'] ['path2analyse']     = VersionKB4Xi['five2ref4uri']

DirectionKB4Xi['six']     = {}
DirectionKB4Xi['six'] ['channel2publish']  = None
DirectionKB4Xi['six'] ['channel2consume']  = None
DirectionKB4Xi['six'] ['queue'] = None
DirectionKB4Xi['six'] ['function2target']  = None
DirectionKB4Xi['six'] ['number2process']   = None
DirectionKB4Xi['six'] ['name2process']     = None
DirectionKB4Xi['six'] ['status2process']   = None
DirectionKB4Xi['six'] ['cc2put']           = "<copy4xi>copy2six</copy4xi>"
DirectionKB4Xi['six'] ['cc2send']          = "<copy4xi>copy2six</copy4xi>"
DirectionKB4Xi['six'] ['cc2get']           = "<roger4xi>roger2six</roger4xi>"
DirectionKB4Xi['six'] ['cc2receive']       = "<roger4xi>roger2six</roger4xi>"
DirectionKB4Xi['six'] ['path2analyse']     = VersionKB4Xi['six2ref4uri']

DirectionKB4Xi['seven']     = {}
DirectionKB4Xi['seven'] ['channel2publish']  = None
DirectionKB4Xi['seven'] ['channel2consume']  = None
DirectionKB4Xi['seven'] ['queue'] = None
DirectionKB4Xi['seven'] ['function2target']  = None
DirectionKB4Xi['seven'] ['number2process']   = None
DirectionKB4Xi['seven'] ['name2process']     = None
DirectionKB4Xi['seven'] ['status2process']   = None
DirectionKB4Xi['seven'] ['cc2put']           = "<copy4xi>copy2seven</copy4xi>"
DirectionKB4Xi['seven'] ['cc2send']          = "<copy4xi>copy2seven</copy4xi>"
DirectionKB4Xi['seven'] ['cc2get']           = "<roger4xi>roger2seven</roger4xi>"
DirectionKB4Xi['seven'] ['cc2receive']       = "<roger4xi>roger2seven</roger4xi>"
DirectionKB4Xi['seven'] ['path2analyse']     = VersionKB4Xi['seven2ref4uri']

DirectionKB4Xi['eight']     = {}
DirectionKB4Xi['eight'] ['channel2publish']  = None
DirectionKB4Xi['eight'] ['channel2consume']  = None
DirectionKB4Xi['eight'] ['queue'] = None
DirectionKB4Xi['eight'] ['function2target']  = None
DirectionKB4Xi['eight'] ['number2process']   = None
DirectionKB4Xi['eight'] ['name2process']     = None
DirectionKB4Xi['eight'] ['status2process']   = None
DirectionKB4Xi['eight'] ['cc2put']           = "<copy4xi>copy2eight</copy4xi>"
DirectionKB4Xi['eight'] ['cc2send']          = "<copy4xi>copy2eight</copy4xi>"
DirectionKB4Xi['eight'] ['cc2get']           = "<roger4xi>roger2eight</roger4xi>"
DirectionKB4Xi['eight'] ['cc2receive']       = "<roger4xi>roger2eight</roger4xi>"
DirectionKB4Xi['eight'] ['path2analyse']     = VersionKB4Xi['eight2ref4uri']

DirectionKB4Xi['nine']     = {}
DirectionKB4Xi['nine'] ['channel2publish']  = None
DirectionKB4Xi['nine'] ['channel2consume']  = None
DirectionKB4Xi['nine'] ['queue'] = None
DirectionKB4Xi['nine'] ['function2target']  = None
DirectionKB4Xi['nine'] ['number2process']   = None
DirectionKB4Xi['nine'] ['name2process']     = None
DirectionKB4Xi['nine'] ['status2process']   = None
DirectionKB4Xi['nine'] ['cc2put']           = "<copy4xi>copy2nine</copy4xi>"
DirectionKB4Xi['nine'] ['cc2send']          = "<copy4xi>copy2nine</copy4xi>"
DirectionKB4Xi['nine'] ['cc2get']           = "<roger4xi>roger2nine</roger4xi>"
DirectionKB4Xi['nine'] ['cc2receive']       = "<roger4xi>roger2nine</roger4xi>"
DirectionKB4Xi['nine'] ['path2analyse']     = VersionKB4Xi['nine2ref4uri']

DirectionKB4Xi['ten']     = {}
DirectionKB4Xi['ten'] ['channel2publish']  = None
DirectionKB4Xi['ten'] ['channel2consume']  = None
DirectionKB4Xi['ten'] ['queue'] = None
DirectionKB4Xi['ten'] ['function2target']  = None
DirectionKB4Xi['ten'] ['number2process']   = None
DirectionKB4Xi['ten'] ['name2process']     = None
DirectionKB4Xi['ten'] ['status2process']   = None
DirectionKB4Xi['ten'] ['cc2put']           = "<copy4xi>copy2ten</copy4xi>"
DirectionKB4Xi['ten'] ['cc2send']          = "<copy4xi>copy2ten</copy4xi>"
DirectionKB4Xi['ten'] ['cc2get']           = "<roger4xi>roger2ten</roger4xi>"
DirectionKB4Xi['ten'] ['cc2receive']       = "<roger4xi>roger2ten</roger4xi>"
DirectionKB4Xi['ten'] ['path2analyse']     = VersionKB4Xi['ten2ref4uri']

DirectionKB4Xi['eleven']     = {}
DirectionKB4Xi['eleven'] ['channel2publish']  = None
DirectionKB4Xi['eleven'] ['channel2consume']  = None
DirectionKB4Xi['eleven'] ['queue'] = None
DirectionKB4Xi['eleven'] ['function2target']  = None
DirectionKB4Xi['eleven'] ['number2process']   = None
DirectionKB4Xi['eleven'] ['name2process']     = None
DirectionKB4Xi['eleven'] ['status2process']   = None
DirectionKB4Xi['eleven'] ['cc2put']           = "<copy4xi>copy2eleven</copy4xi>"
DirectionKB4Xi['eleven'] ['cc2send']          = "<copy4xi>copy2eleven</copy4xi>"
DirectionKB4Xi['eleven'] ['cc2get']           = "<roger4xi>roger2eleven</roger4xi>"
DirectionKB4Xi['eleven'] ['cc2receive']       = "<roger4xi>roger2eleven</roger4xi>"
DirectionKB4Xi['eleven'] ['path2analyse']     = VersionKB4Xi['eleven2ref4uri']

DirectionKB4Xi['twelve']     = {}
DirectionKB4Xi['twelve'] ['channel2publish']  = None
DirectionKB4Xi['twelve'] ['channel2consume']  = None
DirectionKB4Xi['twelve'] ['queue'] = None
DirectionKB4Xi['twelve'] ['function2target']  = None
DirectionKB4Xi['twelve'] ['number2process']   = None
DirectionKB4Xi['twelve'] ['name2process']     = None
DirectionKB4Xi['twelve'] ['status2process']   = None
DirectionKB4Xi['twelve'] ['cc2put']           = "<copy4xi>copy2twelve</copy4xi>"
DirectionKB4Xi['twelve'] ['cc2send']          = "<copy4xi>copy2twelve</copy4xi>"
DirectionKB4Xi['twelve'] ['cc2get']           = "<roger4xi>roger2twelve</roger4xi>"
DirectionKB4Xi['twelve'] ['cc2receive']       = "<roger4xi>roger2twelve</roger4xi>"
DirectionKB4Xi['twelve'] ['path2analyse']     = VersionKB4Xi['twelve2ref4uri']

DirectionKB4Xi['thirteen']     = {}
DirectionKB4Xi['thirteen'] ['channel2publish']  = None
DirectionKB4Xi['thirteen'] ['channel2consume']  = None
DirectionKB4Xi['thirteen'] ['queue'] = None
DirectionKB4Xi['thirteen'] ['function2target']  = None
DirectionKB4Xi['thirteen'] ['number2process']   = None
DirectionKB4Xi['thirteen'] ['name2process']     = None
DirectionKB4Xi['thirteen'] ['status2process']   = None
DirectionKB4Xi['thirteen'] ['cc2put']           = "<copy4xi>copy2thirteen</copy4xi>"
DirectionKB4Xi['thirteen'] ['cc2send']          = "<copy4xi>copy2thirteen</copy4xi>"
DirectionKB4Xi['thirteen'] ['cc2get']           = "<roger4xi>roger2thirteen</roger4xi>"
DirectionKB4Xi['thirteen'] ['cc2receive']       = "<roger4xi>roger2thirteen</roger4xi>"
DirectionKB4Xi['thirteen'] ['path2analyse']     = VersionKB4Xi['thirteen2ref4uri']

DirectionKB4Xi['fourteen']     = {}
DirectionKB4Xi['fourteen'] ['channel2publish']  = None
DirectionKB4Xi['fourteen'] ['channel2consume']  = None
DirectionKB4Xi['fourteen'] ['queue'] = None
DirectionKB4Xi['fourteen'] ['function2target']  = None
DirectionKB4Xi['fourteen'] ['number2process']   = None
DirectionKB4Xi['fourteen'] ['name2process']     = None
DirectionKB4Xi['fourteen'] ['status2process']   = None
DirectionKB4Xi['fourteen'] ['cc2put']           = "<copy4xi>copy2fourteen</copy4xi>"
DirectionKB4Xi['fourteen'] ['cc2send']          = "<copy4xi>copy2fourteen</copy4xi>"
DirectionKB4Xi['fourteen'] ['cc2get']           = "<roger4xi>roger2fourteen</roger4xi>"
DirectionKB4Xi['fourteen'] ['cc2receive']       = "<roger4xi>roger2fourteen</roger4xi>"
DirectionKB4Xi['fourteen'] ['path2analyse']     = VersionKB4Xi['fourteen2ref4uri']

DirectionKB4Xi['fifteen']      = {}
DirectionKB4Xi['fifteen'] ['channel2publish']  = None
DirectionKB4Xi['fifteen'] ['channel2consume']  = None
DirectionKB4Xi['fifteen'] ['queue'] = None
DirectionKB4Xi['fifteen'] ['function2target']  = None
DirectionKB4Xi['fifteen'] ['number2process']   = None
DirectionKB4Xi['fifteen'] ['name2process']     = None
DirectionKB4Xi['fifteen'] ['status2process']   = None
DirectionKB4Xi['fifteen'] ['cc2put']           = "<copy4xi>copy2fifteen</copy4xi>"
DirectionKB4Xi['fifteen'] ['cc2send']          = "<copy4xi>copy2fifteen</copy4xi>"
DirectionKB4Xi['fifteen'] ['cc2get']           = "<roger4xi>roger2fifteen</roger4xi>"
DirectionKB4Xi['fifteen'] ['cc2receive']       = "<roger4xi>roger2fifteen</roger4xi>"
DirectionKB4Xi['fifteen'] ['path2analyse']     = VersionKB4Xi['fifteen2ref4uri']

DirectionKB4Xi['sixteen']      = {}
DirectionKB4Xi['sixteen'] ['channel2publish']  = None
DirectionKB4Xi['sixteen'] ['channel2consume']  = None
DirectionKB4Xi['sixteen'] ['queue'] = None
DirectionKB4Xi['sixteen'] ['function2target']  = None
DirectionKB4Xi['sixteen'] ['number2process']   = None
DirectionKB4Xi['sixteen'] ['name2process']     = None
DirectionKB4Xi['sixteen'] ['status2process']   = None
DirectionKB4Xi['sixteen'] ['cc2put']           = "<copy4xi>copy2sixteen</copy4xi>"
DirectionKB4Xi['sixteen'] ['cc2send']          = "<copy4xi>copy2sixteen</copy4xi>"
DirectionKB4Xi['sixteen'] ['cc2get']           = "<roger4xi>roger2sixteen</roger4xi>"
DirectionKB4Xi['sixteen'] ['cc2receive']       = "<roger4xi>roger2sixteen</roger4xi>"
DirectionKB4Xi['sixteen'] ['path2analyse']     = VersionKB4Xi['sixteen2ref4uri']

DirectionKB4Xi['seventeen']    = {}
DirectionKB4Xi['seventeen'] ['channel2publish']  = None
DirectionKB4Xi['seventeen'] ['channel2consume']  = None
DirectionKB4Xi['seventeen'] ['queue'] = None
DirectionKB4Xi['seventeen'] ['function2target']  = None
DirectionKB4Xi['seventeen'] ['number2process']   = None
DirectionKB4Xi['seventeen'] ['name2process']     = None
DirectionKB4Xi['seventeen'] ['status2process']   = None
DirectionKB4Xi['seventeen'] ['cc2put']           = "<copy4xi>copy2seventeen</copy4xi>"
DirectionKB4Xi['seventeen'] ['cc2send']          = "<copy4xi>copy2seventeen</copy4xi>"
DirectionKB4Xi['seventeen'] ['cc2get']           = "<roger4xi>roger2seventeen</roger4xi>"
DirectionKB4Xi['seventeen'] ['cc2receive']       = "<roger4xi>roger2seventeen</roger4xi>"
DirectionKB4Xi['seventeen'] ['path2analyse']     = VersionKB4Xi['seventeen2ref4uri']

DirectionKB4Xi['eighteen']     = {}
DirectionKB4Xi['eighteen'] ['channel2publish']  = None
DirectionKB4Xi['eighteen'] ['channel2consume']  = None
DirectionKB4Xi['eighteen'] ['queue'] = None
DirectionKB4Xi['eighteen'] ['function2target']  = None
DirectionKB4Xi['eighteen'] ['number2process']   = None
DirectionKB4Xi['eighteen'] ['name2process']     = None
DirectionKB4Xi['eighteen'] ['status2process']   = None
DirectionKB4Xi['eighteen'] ['cc2put']           = "<copy4xi>copy2eighteen</copy4xi>"
DirectionKB4Xi['eighteen'] ['cc2send']          = "<copy4xi>copy2eighteen</copy4xi>"
DirectionKB4Xi['eighteen'] ['cc2get']           = "<roger4xi>roger2eighteen</roger4xi>"
DirectionKB4Xi['eighteen'] ['cc2receive']       = "<roger4xi>roger2eighteen</roger4xi>"
DirectionKB4Xi['eighteen'] ['path2analyse']     = VersionKB4Xi['eighteen2ref4uri']

DirectionKB4Xi['nineteen']     = {}
DirectionKB4Xi['nineteen'] ['channel2publish']  = None
DirectionKB4Xi['nineteen'] ['channel2consume']  = None
DirectionKB4Xi['nineteen'] ['queue'] = None
DirectionKB4Xi['nineteen'] ['function2target']  = None
DirectionKB4Xi['nineteen'] ['number2process']   = None
DirectionKB4Xi['nineteen'] ['name2process']     = None
DirectionKB4Xi['nineteen'] ['status2process']   = None
DirectionKB4Xi['nineteen'] ['cc2put']           = "<copy4xi>copy2nineteen</copy4xi>"
DirectionKB4Xi['nineteen'] ['cc2send']          = "<copy4xi>copy2nineteen</copy4xi>"
DirectionKB4Xi['nineteen'] ['cc2get']           = "<roger4xi>roger2nineteen</roger4xi>"
DirectionKB4Xi['nineteen'] ['cc2receive']       = "<roger4xi>roger2nineteen</roger4xi>"
DirectionKB4Xi['nineteen'] ['path2analyse']     = VersionKB4Xi['nineteen2ref4uri']

DirectionKB4Xi['twenty']       = {}
DirectionKB4Xi['twenty'] ['channel2publish']  = None
DirectionKB4Xi['twenty'] ['channel2consume']  = None
DirectionKB4Xi['twenty'] ['queue'] = None
DirectionKB4Xi['twenty'] ['function2target']  = None
DirectionKB4Xi['twenty'] ['number2process']   = None
DirectionKB4Xi['twenty'] ['name2process']     = None
DirectionKB4Xi['twenty'] ['status2process']   = None
DirectionKB4Xi['twenty'] ['cc2put']           = "<copy4xi>copy2twenty</copy4xi>"
DirectionKB4Xi['twenty'] ['cc2send']          = "<copy4xi>copy2twenty</copy4xi>"
DirectionKB4Xi['twenty'] ['cc2get']           = "<roger4xi>roger2twenty</roger4xi>"
DirectionKB4Xi['twenty'] ['cc2receive']       = "<roger4xi>roger2twenty</roger4xi>"
DirectionKB4Xi['twenty'] ['path2analyse']     = VersionKB4Xi['twenty2ref4uri']

DirectionKB4Xi['twentyone']    = {}
DirectionKB4Xi['twentyone'] ['channel2publish']  = None
DirectionKB4Xi['twentyone'] ['channel2consume']  = None
DirectionKB4Xi['twentyone'] ['queue'] = None
DirectionKB4Xi['twentyone'] ['function2target']  = None
DirectionKB4Xi['twentyone'] ['number2process']   = None
DirectionKB4Xi['twentyone'] ['name2process']     = None
DirectionKB4Xi['twentyone'] ['status2process']   = None
DirectionKB4Xi['twentyone'] ['cc2put']           = "<copy4xi>copy2twentyone</copy4xi>"
DirectionKB4Xi['twentyone'] ['cc2send']          = "<copy4xi>copy2twentyone</copy4xi>"
DirectionKB4Xi['twentyone'] ['cc2get']           = "<roger4xi>roger2twentyone</roger4xi>"
DirectionKB4Xi['twentyone'] ['cc2receive']       = "<roger4xi>roger2twentyone</roger4xi>"
DirectionKB4Xi['twentyone'] ['path2analyse']     = VersionKB4Xi['twentyone2ref4uri']

DirectionKB4Xi['twentytwo']    = {}
DirectionKB4Xi['twentytwo'] ['channel2publish']  = None
DirectionKB4Xi['twentytwo'] ['channel2consume']  = None
DirectionKB4Xi['twentytwo'] ['queue'] = None
DirectionKB4Xi['twentytwo'] ['function2target']  = None
DirectionKB4Xi['twentytwo'] ['number2process']   = None
DirectionKB4Xi['twentytwo'] ['name2process']     = None
DirectionKB4Xi['twentytwo'] ['status2process']   = None
DirectionKB4Xi['twentytwo'] ['cc2put']           = "<copy4xi>copy2twentytwo</copy4xi>"
DirectionKB4Xi['twentytwo'] ['cc2send']          = "<copy4xi>copy2twentytwo</copy4xi>"
DirectionKB4Xi['twentytwo'] ['cc2get']           = "<roger4xi>roger2twentytwo</roger4xi>"
DirectionKB4Xi['twentytwo'] ['cc2receive']       = "<roger4xi>roger2twentytwo</roger4xi>"
DirectionKB4Xi['twentytwo'] ['path2analyse']     = VersionKB4Xi['twentytwo2ref4uri']

DirectionKB4Xi['twentythree']  = {}
DirectionKB4Xi['twentythree'] ['channel2publish']  = None
DirectionKB4Xi['twentythree'] ['channel2consume']  = None
DirectionKB4Xi['twentythree'] ['queue'] = None
DirectionKB4Xi['twentythree'] ['function2target']  = None
DirectionKB4Xi['twentythree'] ['number2process']   = None
DirectionKB4Xi['twentythree'] ['name2process']     = None
DirectionKB4Xi['twentythree'] ['status2process']   = None
DirectionKB4Xi['twentythree'] ['cc2put']           = "<copy4xi>copy2twentythree</copy4xi>"
DirectionKB4Xi['twentythree'] ['cc2send']          = "<copy4xi>copy2twentythree</copy4xi>"
DirectionKB4Xi['twentythree'] ['cc2get']           = "<roger4xi>roger2twentythree</roger4xi>"
DirectionKB4Xi['twentythree'] ['cc2receive']       = "<roger4xi>roger2twentythree</roger4xi>"
DirectionKB4Xi['twentythree'] ['path2analyse']     = VersionKB4Xi['twentythree2ref4uri']

DirectionKB4Xi['twentyfour']   = {}
DirectionKB4Xi['twentyfour'] ['channel2publish']  = None
DirectionKB4Xi['twentyfour'] ['channel2consume']  = None
DirectionKB4Xi['twentyfour'] ['queue'] = None
DirectionKB4Xi['twentyfour'] ['function2target']  = None
DirectionKB4Xi['twentyfour'] ['number2process']   = None
DirectionKB4Xi['twentyfour'] ['name2process']     = None
DirectionKB4Xi['twentyfour'] ['status2process']   = None
DirectionKB4Xi['twentyfour'] ['cc2put']           = "<copy4xi>copy2twentyfour</copy4xi>"
DirectionKB4Xi['twentyfour'] ['cc2send']          = "<copy4xi>copy2twentyfour</copy4xi>"
DirectionKB4Xi['twentyfour'] ['cc2get']           = "<roger4xi>roger2twentyfour</roger4xi>"
DirectionKB4Xi['twentyfour'] ['cc2receive']       = "<roger4xi>roger2twentyfour</roger4xi>"
DirectionKB4Xi['twentyfour'] ['path2analyse']     = VersionKB4Xi['twentyfour2ref4uri']

DirectionKB4Xi['twentyfive']   = {}
DirectionKB4Xi['twentyfive'] ['channel2publish']  = None
DirectionKB4Xi['twentyfive'] ['channel2consume']  = None
DirectionKB4Xi['twentyfive'] ['queue'] = None
DirectionKB4Xi['twentyfive'] ['function2target']  = None
DirectionKB4Xi['twentyfive'] ['number2process']   = None
DirectionKB4Xi['twentyfive'] ['name2process']     = None
DirectionKB4Xi['twentyfive'] ['status2process']   = None
DirectionKB4Xi['twentyfive'] ['cc2put']           = "<copy4xi>copy2twentyfive</copy4xi>"
DirectionKB4Xi['twentyfive'] ['cc2send']          = "<copy4xi>copy2twentyfive</copy4xi>"
DirectionKB4Xi['twentyfive'] ['cc2get']           = "<roger4xi>roger2twentyfive</roger4xi>"
DirectionKB4Xi['twentyfive'] ['cc2receive']       = "<roger4xi>roger2twentyfive</roger4xi>"
DirectionKB4Xi['twentyfive'] ['path2analyse']     = VersionKB4Xi['twentyfive2ref4uri']

DirectionKB4Xi['twentysix']    = {}
DirectionKB4Xi['twentysix'] ['channel2publish']  = None
DirectionKB4Xi['twentysix'] ['channel2consume']  = None
DirectionKB4Xi['twentysix'] ['queue'] = None
DirectionKB4Xi['twentysix'] ['function2target']  = None
DirectionKB4Xi['twentysix'] ['number2process']   = None
DirectionKB4Xi['twentysix'] ['name2process']     = None
DirectionKB4Xi['twentysix'] ['status2process']   = None
DirectionKB4Xi['twentysix'] ['cc2put']           = "<copy4xi>copy2twentysix</copy4xi>"
DirectionKB4Xi['twentysix'] ['cc2send']          = "<copy4xi>copy2twentysix</copy4xi>"
DirectionKB4Xi['twentysix'] ['cc2get']           = "<roger4xi>roger2twentysix</roger4xi>"
DirectionKB4Xi['twentysix'] ['cc2receive']       = "<roger4xi>roger2twentysix</roger4xi>"
DirectionKB4Xi['twentysix'] ['path2analyse']     = VersionKB4Xi['twentysix2ref4uri']

DirectionKB4Xi['twentyseven']  = {}
DirectionKB4Xi['twentyseven'] ['channel2publish']  = None
DirectionKB4Xi['twentyseven'] ['channel2consume']  = None
DirectionKB4Xi['twentyseven'] ['queue'] = None
DirectionKB4Xi['twentyseven'] ['function2target']  = None
DirectionKB4Xi['twentyseven'] ['number2process']   = None
DirectionKB4Xi['twentyseven'] ['name2process']     = None
DirectionKB4Xi['twentyseven'] ['status2process']   = None
DirectionKB4Xi['twentyseven'] ['cc2put']           = "<copy4xi>copy2twentyseven</copy4xi>"
DirectionKB4Xi['twentyseven'] ['cc2send']          = "<copy4xi>copy2twentyseven</copy4xi>"
DirectionKB4Xi['twentyseven'] ['cc2get']           = "<roger4xi>roger2twentyseven</roger4xi>"
DirectionKB4Xi['twentyseven'] ['cc2receive']       = "<roger4xi>roger2twentyseven</roger4xi>"
DirectionKB4Xi['twentyseven'] ['path2analyse']     = VersionKB4Xi['twentyseven2ref4uri']

DirectionKB4Xi['twentyeight']  = {}
DirectionKB4Xi['twentyeight'] ['channel2publish']  = None
DirectionKB4Xi['twentyeight'] ['channel2consume']  = None
DirectionKB4Xi['twentyeight'] ['queue'] = None
DirectionKB4Xi['twentyeight'] ['function2target']  = None
DirectionKB4Xi['twentyeight'] ['number2process']   = None
DirectionKB4Xi['twentyeight'] ['name2process']     = None
DirectionKB4Xi['twentyeight'] ['status2process']   = None
DirectionKB4Xi['twentyeight'] ['cc2put']           = "<copy4xi>copy2twentyeight</copy4xi>"
DirectionKB4Xi['twentyeight'] ['cc2send']          = "<copy4xi>copy2twentyeight</copy4xi>"
DirectionKB4Xi['twentyeight'] ['cc2get']           = "<roger4xi>roger2twentyeight</roger4xi>"
DirectionKB4Xi['twentyeight'] ['cc2receive']       = "<roger4xi>roger2twentyeight</roger4xi>"
DirectionKB4Xi['twentyeight'] ['path2analyse']     = VersionKB4Xi['twentyeight2ref4uri']

DirectionKB4Xi['twentynine']  = {}
DirectionKB4Xi['twentynine'] ['channel2publish']  = None
DirectionKB4Xi['twentynine'] ['channel2consume']  = None
DirectionKB4Xi['twentynine'] ['queue'] = None
DirectionKB4Xi['twentynine'] ['function2target']  = None
DirectionKB4Xi['twentynine'] ['number2process']   = None
DirectionKB4Xi['twentynine'] ['name2process']     = None
DirectionKB4Xi['twentynine'] ['status2process']   = None
DirectionKB4Xi['twentynine'] ['cc2put']           = "<copy4xi>copy2twentynine</copy4xi>"
DirectionKB4Xi['twentynine'] ['cc2send']          = "<copy4xi>copy2twentynine</copy4xi>"
DirectionKB4Xi['twentynine'] ['cc2get']           = "<roger4xi>roger2twentynine</roger4xi>"
DirectionKB4Xi['twentynine'] ['cc2receive']       = "<roger4xi>roger2twentynine</roger4xi>"
DirectionKB4Xi['twentynine'] ['path2analyse']     = VersionKB4Xi['twentynine2ref4uri']

DirectionKB4Xi['thirty']       = {}
DirectionKB4Xi['thirty'] ['channel2publish']  = None
DirectionKB4Xi['thirty'] ['channel2consume']  = None
DirectionKB4Xi['thirty'] ['queue'] = None
DirectionKB4Xi['thirty'] ['function2target']  = None
DirectionKB4Xi['thirty'] ['number2process']   = None
DirectionKB4Xi['thirty'] ['name2process']     = None
DirectionKB4Xi['thirty'] ['status2process']   = None
DirectionKB4Xi['thirty'] ['cc2put']           = "<copy4xi>copy2thirty</copy4xi>"
DirectionKB4Xi['thirty'] ['cc2send']          = "<copy4xi>copy2thirty</copy4xi>"
DirectionKB4Xi['thirty'] ['cc2get']           = "<roger4xi>roger2thirty</roger4xi>"
DirectionKB4Xi['thirty'] ['cc2receive']       = "<roger4xi>roger2thirty</roger4xi>"
DirectionKB4Xi['thirty'] ['path2analyse']     = VersionKB4Xi['thirty2ref4uri']

DirectionKB4Xi['thirtyone']    = {}
DirectionKB4Xi['thirtyone'] ['channel2publish']  = None
DirectionKB4Xi['thirtyone'] ['channel2consume']  = None
DirectionKB4Xi['thirtyone'] ['queue'] = None
DirectionKB4Xi['thirtyone'] ['function2target']  = None
DirectionKB4Xi['thirtyone'] ['number2process']   = None
DirectionKB4Xi['thirtyone'] ['name2process']     = None
DirectionKB4Xi['thirtyone'] ['status2process']   = None
DirectionKB4Xi['thirtyone'] ['cc2put']           = "<copy4xi>copy2thirtyone</copy4xi>"
DirectionKB4Xi['thirtyone'] ['cc2send']          = "<copy4xi>copy2thirtyone</copy4xi>"
DirectionKB4Xi['thirtyone'] ['cc2get']           = "<roger4xi>roger2thirtyone</roger4xi>"
DirectionKB4Xi['thirtyone'] ['cc2receive']       = "<roger4xi>roger2thirtyone</roger4xi>"
DirectionKB4Xi['thirtyone'] ['path2analyse']     = VersionKB4Xi['thirtyone2ref4uri']

DirectionKB4Xi['thirtytwo']    = {}
DirectionKB4Xi['thirtytwo'] ['channel2publish']  = None
DirectionKB4Xi['thirtytwo'] ['channel2consume']  = None
DirectionKB4Xi['thirtytwo'] ['queue'] = None
DirectionKB4Xi['thirtytwo'] ['function2target']  = None
DirectionKB4Xi['thirtytwo'] ['number2process']   = None
DirectionKB4Xi['thirtytwo'] ['name2process']     = None
DirectionKB4Xi['thirtytwo'] ['status2process']   = None
DirectionKB4Xi['thirtytwo'] ['cc2put']           = "<copy4xi>copy2thirtytwo</copy4xi>"
DirectionKB4Xi['thirtytwo'] ['cc2send']          = "<copy4xi>copy2thirtytwo</copy4xi>"
DirectionKB4Xi['thirtytwo'] ['cc2get']           = "<roger4xi>roger2thirtytwo</roger4xi>"
DirectionKB4Xi['thirtytwo'] ['cc2receive']       = "<roger4xi>roger2thirtytwo</roger4xi>"
DirectionKB4Xi['thirtytwo'] ['path2analyse']     = VersionKB4Xi['thirtytwo2ref4uri']

DirectionKB4Xi['thirtythree']  = {}
DirectionKB4Xi['thirtythree'] ['channel2publish']  = None
DirectionKB4Xi['thirtythree'] ['channel2consume']  = None
DirectionKB4Xi['thirtythree'] ['queue'] = None
DirectionKB4Xi['thirtythree'] ['function2target']  = None
DirectionKB4Xi['thirtythree'] ['number2process']   = None
DirectionKB4Xi['thirtythree'] ['name2process']     = None
DirectionKB4Xi['thirtythree'] ['status2process']   = None
DirectionKB4Xi['thirtythree'] ['cc2put']           = "<copy4xi>copy2thirtythree</copy4xi>"
DirectionKB4Xi['thirtythree'] ['cc2send']          = "<copy4xi>copy2thirtythree</copy4xi>"
DirectionKB4Xi['thirtythree'] ['cc2get']           = "<roger4xi>roger2thirtythree</roger4xi>"
DirectionKB4Xi['thirtythree'] ['cc2receive']       = "<roger4xi>roger2thirtythree</roger4xi>"
DirectionKB4Xi['thirtythree'] ['path2analyse']     = VersionKB4Xi['thirtythree2ref4uri']

keys2DirectionKB4Xi = DirectionKB4Xi.keys()
key2DirectionKB4Xi  = 'thirteen'
#dynamic-end


# ------------------------------
# paths to input
# ------------------------------
master2ref4uri  = VersionKB4Xi['master2ref4uri']
dragon2ref4uri  = VersionKB4Xi['dragon2ref4uri']
#dynamic-start
zero2ref4uri    = VersionKB4Xi['zero2ref4uri']
one2ref4uri     = VersionKB4Xi['one2ref4uri']
two2ref4uri     = VersionKB4Xi['two2ref4uri']
three2ref4uri   = VersionKB4Xi['three2ref4uri']
four2ref4uri    = VersionKB4Xi['four2ref4uri']
five2ref4uri    = VersionKB4Xi['five2ref4uri']
six2ref4uri     = VersionKB4Xi['six2ref4uri']
seven2ref4uri   = VersionKB4Xi['seven2ref4uri']
eight2ref4uri   = VersionKB4Xi['eight2ref4uri'] 
nine2ref4uri    = VersionKB4Xi['nine2ref4uri'] 
ten2ref4uri     = VersionKB4Xi['ten2ref4uri'] 
eleven2ref4uri  = VersionKB4Xi['eleven2ref4uri']    
twelve2ref4uri  = VersionKB4Xi['twelve2ref4uri']             
thirteen2ref4uri    = VersionKB4Xi['thirteen2ref4uri']
fourteen2ref4uri    = VersionKB4Xi['fourteen2ref4uri']
fifteen2ref4uri     = VersionKB4Xi['fifteen2ref4uri']
sixteen2ref4uri     = VersionKB4Xi['sixteen2ref4uri']
seventeen2ref4uri   = VersionKB4Xi['seventeen2ref4uri']
eighteen2ref4uri    = VersionKB4Xi['eighteen2ref4uri']
nineteen2ref4uri    = VersionKB4Xi['nineteen2ref4uri']
twenty2ref4uri      = VersionKB4Xi['twenty2ref4uri']
twentyone2ref4uri   = VersionKB4Xi['twentyone2ref4uri']
twentytwo2ref4uri   = VersionKB4Xi['twentytwo2ref4uri']
twentythree2ref4uri = VersionKB4Xi['twentythree2ref4uri']
twentyfour2ref4uri  = VersionKB4Xi['twentyfour2ref4uri']
twentyfive2ref4uri  = VersionKB4Xi['twentyfive2ref4uri']
twentysix2ref4uri   = VersionKB4Xi['twentysix2ref4uri']
twentyseven2ref4uri = VersionKB4Xi['twentyseven2ref4uri']
twentyeight2ref4uri = VersionKB4Xi['twentyeight2ref4uri']
twentynine2ref4uri  = VersionKB4Xi['twentynine2ref4uri']
thirty2ref4uri      = VersionKB4Xi['thirty2ref4uri']
thirtyone2ref4uri   = VersionKB4Xi['thirtyone2ref4uri']
thirtytwo2ref4uri   = VersionKB4Xi['thirtytwo2ref4uri']
thirtythree2ref4uri = VersionKB4Xi['thirtythree2ref4uri']
#dynamic-end         

PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<define4xi definition = "

#"
#/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4fecth" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4fecth():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 00A/33) OF SET2TRACE4FECTH - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 00B/33) OF SET2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 002A/33) OF SET2TRACE4FECTH - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 0033/33) OF SET2TRACE4FECTH - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi())
    # 10:55:18 01/09/15 FLE Standard Time 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4fetch" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4fetch():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 001A/33) of DENY2TRACE4FECTH: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...)  19:04:49 01/21/15 FLE Standard Time
    print("(Step 001B/33) OF DENY2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x02A9A250>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 001C/33) OF DENY2TRACE4FECTH - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 001D/33) OF DENY2TRACE4FECTH - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 001E/33) OF DENY2TRACE4FECTH - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEROOT4XI PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 001F/33) OF DENY2TRACE4FECTH - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 001Z/33) OF DENY2TRACE4FECTH *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 001G/33) OF DENY2TRACE4FECTH - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 002F/33) OF DENY2TRACE4FECTH - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 0033/33) OF SET2TRACE4FECTH - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi())
    # COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...)  19:04:49 01/21/15 FLE Standard Time
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x02A9A250>
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         'Pipe4Xi': 'NACK4TRACE',
         'Queue4Xi': 'NACK4TRACE',         
         'Process4Xi': 'NACK4TRACE'
         #dynamic-start

         #dynamic-end
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # Pipe4Xi
        # Process4Xi
        # Queue4Xi
        # ...

    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    # 

    
     
#</function4xi>             
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
# print XML trace
#"> 
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):

    class2print  = "shoot2dragon4uri"
    method2print = "shoot2dragon4uri" 
        
    message2print = "{passed" + "; t2xi-passed-to-print-trace4xi: " + str(t2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    #    

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..//..//..//..//web//xml//sense-shoot2dragon4uri5test.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/studio4xi/owl/studio4xi.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/studio4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing shoot2dragon4uri5test.py.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">shoot2dragon4uri5test.py sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..//..//..//..//web//xml//reason-shoot2dragon4uri5test.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/studio4xi/owl/studio4xi.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/studio4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for shoot2dragon4uri5test.py.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..//..//..//..//web//xml//ace-shoot2dragon4uri5test.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/studio4xi/owl/studio4xi.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/studio4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for shoot2dragon4uri5test.py.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of shoot2dragon4uri5test.py.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   reviewing all tests
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global ack2message4index

    global ack4queues
    global nack4queues

    global ack4pipes
    global nack4pipes

    global ack4process
    global nack4process

    global ack4start
    global nack4start   
        
    global ack4run
    global nack4run
    

    global master2ref4uri
    global dragon2ref4uri   
    #dynamic-start

    #dynamic-end
    
    global path2temp4xi

    global t2xi
    global trace_object_count    

       
                       
    # ------------------------------------------------------------------------------------------------- 
    # INITIALIZE
    # -------------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 0A/33) OF TEST5SHOOT2DRAGON4URI - SET T2XI TO: ", t2xi)  
    # <print4xi.Print4Xi object at 0x02A9A250> 

    set2trace4fecth()                                                                                               # trace all classes and functions in the system
    deny2trace4fetch()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                               # tailor trace for this test    

    pipe2fetch = Pipe4Xi()
    queue2fetch = Queue4Xi()
    
       
    # --------------------------------------------------------------------------------------------- 
    # START
    # ---------------------------------------------------------------------------------------------        
    print ('(STEP 1/33) OF TEST5SHOOT2DRAGON4URI - TRYING TO PRINT INPUT PATHS ', time4xi())
    try:
        print ('(STEP 1A/33) OF TEST5SHOOT2DRAGON4URI - MASTER2ANALYSE4XI: ', master2ref4uri)
        print ('(STEP 1B/33) OF TEST5SHOOT2DRAGON4URI - DRAGON2ANALYSE4XI: ', dragon2ref4uri) 
        # J://temp//yosense//test2master//
        # F://temp//yosense//test2dragon//
        #dynamic-start
        
        #dynamic-end
    except:                                       
        print ('(STEP 1Z/33) OF TEST5SHOOT2DRAGON4URI *** FAILED TO PRINT INPUT PATHS ', time4xi())
    
    
    #dynamic-start

    #dynamic-end
    # =============================================================================================   
    # (Step 3/33)
    # =============================================================================================       
    print("(STEP 3A/33) OF TEST5SHOOT2DRAGON4URI - CREATING DRAGON PIPE WITH CONSUMER AND PUBLISHER ENDS ", time4xi())
    # 
    try:
        # -----------------------------------------------------------------------------------------    
        # DRAGON PIPE
        # -----------------------------------------------------------------------------------------     
        pipe2dragon_consumer_channel, pipe2dragon_publisher_channel = Pipe4Xi()
        print("(STEP 3B1/33) OF TEST5SHOOT2DRAGON4URI - CREATED PIPE2DRAGON_CONSUMER_CHANNEL")   
        print(pipe2dragon_consumer_channel)
        # CREATED PIPE2DRAGON_CONSUMER_CHANNEL <pipeconnection4xi.PipeConnection4Xi object at 0x025EB190>
        print("(STEP 3B2/33) OF TEST5SHOOT2DRAGON4URI - CREATED PIPE2DRAGON_PUBLISHER_CHANNEL")  
        print(pipe2dragon_publisher_channel)
        # CREATED PIPE2DRAGON_PUBLISHER_CHANNEL <pipeconnection4xi.PipeConnection4Xi object at 0x025EB7D0>
    except:
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        print("(STEP ZB/33) OF TEST5SHOOT2DRAGON4URI *** FAILED TO CREATE DRAGON PIPE WITH CONSUMER AND PUBLISHER ENDS ", time4xi())  
    
    #dynamic-start
                               
    #dynamic-end
    try:
        # -----------------------------------------------------------------------------------------    
        # DRAGON QUEUE
        # -----------------------------------------------------------------------------------------     
        print('=' *33)    
        print("(STEP 3L1/33) OF TEST5SHOOT2DRAGON4URI - CREATING QUEUE2DRAGON")
        print('=' *33)           
             
        queue2dragon = Queue4Xi()
        
        print('=' *33)    
        print("(STEP 3L2/33) OF TEST5SHOOT2DRAGON4URI - CREATED QUEUE2DRAGON: ", queue2dragon)
        # CREATED QUEUE2DRAGON:  <queue4xi.Queue4Xi object at 0x02294EF0> 
    except:
        print("(STEP 3ZL/33) OF TEST5SHOOT2DRAGON4URI *** FAILED TO CREATE QUEUE2DRAGON ***")            
   
    #dynamic-start

    #dynamic-end
    
    # =============================================================================================   
    # (Step 4/33) - DRAGON COMMAND AND CONTROL PUT TO QUEUE
    # =============================================================================================  
    print("(STEP 4A1/33) OF TEST5SHOOT2DRAGON4URI - TRYING TO PUT DRAGON COMMAND AND CONTROL MESSAGES ", time4xi())
    try:
        # -------------------------------------------------------------------------------------------------
        # PUT COMMAND AND CONTROL MESSAGES TO DRAGON                         
        # ------------------------------------------------------------------------------------------------- 
        message2put4dragon = "<copy4xi>copy2dragon</copy4xi>"
        queue2dragon.put(message2put4dragon)
        print("(STEP 4A2/33) OF TEST5SHOOT2DRAGON4URI - PUT TO QUEUE2DRAGON: ", queue2dragon, " MESSAGE2PUT4DRAGON: " , message2put4dragon)
        # PUT TO QUEUE2DRAGON:  <queue4xi.Queue4Xi object at 0x02294EF0>  MESSAGE2PUT4DRAGON:  <copy4xi>copy2dragon</copy4xi>
    except:
        print("(STEP 4Z1/33) OF TEST5SHOOT2DRAGON4URI *** FAILED TO PUT DRAGON COMMAND AND CONTROL MESSAGES ", time4xi())

    #dynamic-start

    #dynamic-end             
    
    print("(STEP 4C1/33) OF TEST5SHOOT2DRAGON4URI - TRYING TO SEND COMMAND AND CONTROL MESSAGES TO DRAGON PIPE ", time4xi()) 
    try:    
        # -------------------------------------------------------------------------------------------------
        # SEND COMMAND AND CONTROL MESSAGES TO DRAGON                          
        # -------------------------------------------------------------------------------------------------                 
        message2send4dragon = "<copy4xi>copy2dragon</copy4xi>"
        pipe2dragon_publisher_channel.send(message2send4dragon)
        print("(STEP 4C2/33) OF TEST5SHOOT2DRAGON4URI - SENT TO PIPE2DRAGON_PUBLISHER_CHANNEL: ", pipe2dragon_publisher_channel, " MESSAGE2SEND4DRAGON: " , message2send4dragon)
        # SENT TO PIPE2DRAGON_PUBLISHER_CHANNEL:  <pipeconnection4xi.PipeConnection4Xi object at 0x025EB7D0>  MESSAGE2SEND4DRAGON:  <copy4xi>copy2dragon</copy4xi>
    except:
        print("(STEP 4Z3/33) OF TEST5SHOOT2DRAGON4URI *** FAILED SEND COMMAND AND CONTROL MESSAGES TO DRAGON PIPE ", time4xi())   
    
    
    #dynamic-start
  
    #dynamic-end
    
    
    print("(STEP 8A1/33) OF TEST5SHOOT2DRAGON4URI - TRYING WITH PARAMETERS FOR DRAGON ", time4xi())                    
    try:
        # ------------------------------------------------------------------------------ 
        # DRAGON-GUN WITH MULTIPROCESSING4XI
        # ------------------------------------------------------------------------------     
        print("(STEP 8A2/33) OF TEST5SHOOT2DRAGON4URI - PASSING QUEUE2DRAGON ", queue2dragon)
        # PASSING QUEUE2DRAGON  <queue4xi.Queue4Xi object at 0x02294EF0>
        print("(STEP 8A3/33) OF TEST5SHOOT2DRAGON4URI - PASSING PIPE2DRAGON_CONSUMER_CHANNEl ", pipe2dragon_consumer_channel)
        # PASSING PIPE2DRAGON_CONSUMER_CHANNEl  <pipeconnection4xi.PipeConnection4Xi object at 0x025EB190>
        print("(STEP 8A4/33) OF TEST5SHOOT2DRAGON4URI - PASSING PIPE2DRAGON_PUBLISHER_CHANNEL ", pipe2dragon_publisher_channel )
        # PASSING PIPE2DRAGON_PUBLISHER_CHANNEL  <pipeconnection4xi.PipeConnection4Xi object at 0x025EB7D0>
        print("(STEP 8A5/33) OF TEST5SHOOT2DRAGON4URI - PASSING DRAGON2ANALYSE4SEARCH ", dragon2ref4uri)
        # PASSING DRAGON2ANALYSE4SEARCH  F://temp//yosense//test2dragon//
        print("(STEP 8A6/33) OF TEST5SHOOT2DRAGON4URI - USING TARPEGT FUNCTION GUN2DRAGON4SEARCH ", gun2dragon4uri)
        # USING TARPEGT FUNCTION GUN2DRAGON4SEARCH  <function gun2dragon4uri at 0x027BC150>
    except:
        print("(STEP 8Z1/33) OF TEST5SHOOT2DRAGON4URI *** FAILED WITH PARAMETERS FOR DRAGON ", time4xi())
     
    print("(STEP 8B1/33) OF TEST5SHOOT2DRAGON4URI - TRYING TO CREATE DRAGON PROCESS WITH TARGET FUNCTION ", time4xi())            
    try:         
        # -----------------------------------------------------------------------------------------    
        # DRAGON-PROCESS WITH TARGET FUNCTION CREATION
        # -----------------------------------------------------------------------------------------                     
        p2dragon = Process4Xi(target=gun2dragon4uri, args=(queue2dragon, pipe2dragon_consumer_channel, pipe2dragon_publisher_channel, dragon2ref4uri))
        print("(STEP 8B2/33) OF TEST5SHOOT2DRAGON4URI - CREATED DRAGON PROCESS OBJECT P2DRAGON: ", p2dragon)                     
        # 
    except:
        print("(STEP 8Z2/33) OF TEST5SHOOT2DRAGON4URI *** FAILED TO CREATE DRAGON PROCESS WITH TARGET FUNCTION ", time4xi())
    
    try:        
        # -----------------------------------------------------------------------------------------    
        # DRAGON-PROCESS NAME
        # -----------------------------------------------------------------------------------------                        
        name2dragon = p2dragon.name
        print("(STEP 8B3/33) OF TEST5SHOOT2DRAGON4URI - CREATED DRAGON PROCESS NAME: ", name2dragon) 
        # CREATED DRAGON PROCESS NAME:  Process4Xi-1
    except:
        print("(STEP 8Z3/33) OF TEST5SHOOT2DRAGON4URI *** FAILED TO GET NAME OF DRAGON PROCESS ", time4xi())
            
    try:         
        # -----------------------------------------------------------------------------------------    
        # DRAGON-PROCESS START
        # ----------------------------------------------------------------------------------------- 
        p2dragon.start()
        print("(STEP 8B4/33) OF TEST5SHOOT2DRAGON4URI - STARTED DRAGON PROCESS NAME: ", name2dragon)
        # STARTED DRAGON PROCESS NAME:  Process4Xi-1 
    except:
        print("(STEP 8Z4/33) OF TEST5SHOOT2DRAGON4URI *** FAILED TO START PROCESS ", time4xi())
        
    try:        
        # -----------------------------------------------------------------------------------------    
        # DRAGON-PROCESS ALIVE CHECK
        # -----------------------------------------------------------------------------------------                   
        status4p2dragon = p2dragon.is_alive()
        print("(STEP 8B5/33) OF TEST5SHOOT2DRAGON4URI - DRAGON PROCESS STATUS: ", status4p2dragon)
        # DRAGON PROCESS STATUS:  True
    except:
        print("(STEP 8Z5/33) OF TEST5SHOOT2DRAGON4URI *** FAILED TO CHECK IF DRAGON PROCESS IS ALIVE ", time4xi())
        
                
    try:            
        # -----------------------------------------------------------------------------------------    
        # DRAGON-PROCESS RUN
        # -----------------------------------------------------------------------------------------
        p2dragon.run()
        print("(STEP 8B6/33) OF TEST5SHOOT2DRAGON4URI - PERFORMED RUN COMMAND TO DRAGON PROCESS NAME: ", name2dragon)
        # PERFORMED RUN COMMAND TO DRAGON PROCESS NAME:  Process4Xi-1
        ack4run = True 
    except:
        print("(STEP 8Z6/33) OF TEST5SHOOT2DRAGON4URI *** FAILED TO RUN DRAGON PROCESS ", time4xi())
        

    try:
        # --------------------------------------------------------------------------------
        # DRAGON-PROCESS - GETTING COMMUNICATION AND CONTROL MESSAGES FROM QUEUES                         
        # --------------------------------------------------------------------------------   
        print("(STEP 8B7/33) OF TEST5SHOOT2DRAGON4URI - GETTING COMMUNICATION AND CONTROL MESSAGES FROM DRAGON QUEUE ", time4xi())
        # 
        message2get4dragon = queue2dragon.get()
        print("(Step 8B8/33) OF TEST5SHOOT2DRAGON4URI - GOT FROM QUEUE2DRAGON: ", queue2dragon, " MESSAGE: ", message2get4dragon)
        # GOT FROM QUEUE2DRAGON:  <queue4xi.Queue4Xi object at 0x02294EF0>  MESSAGE:  <roger4xi>roger2dragon</roger4xi>
    except:
        print("(STEP 8Z8/33) OF TEST5SHOOT2DRAGON4URI *** FAILED GETTING COMMUNICATION AND CONTROL MESSAGES FROM DRAGON QUEUE ", time4xi()) 
                    
    try:
        # --------------------------------------------------------------------------------
        # DRAGON-PROCESS - RECEIVING COMMUNICATION AND CONTROL MESSAGES FROM PIPES                          
        # --------------------------------------------------------------------------------       
        print("(Step 8B8/33) OF TEST5SHOOT2DRAGON4URI - RECEIVING COMMUNICATION AND CONTROL MESSAGES FROM DRAGON PIPE ", time4xi())  
        # RECEIVED FROM PIPE2DRAGON_CONSUMER_CHANNEL:  <pipeconnection4xi.PipeConnection4Xi object at 0x025EB190>  MESSAGE:  <roger4xi>roger2dragon</roger4xi>
        message2receive4dragon = pipe2dragon_consumer_channel.recv()
        print("(Step 8B9/33) OF TEST5SHOOT2DRAGON4URI - RECEIVED FROM PIPE2DRAGON_CONSUMER_CHANNEL: ", pipe2dragon_consumer_channel, " MESSAGE: ", message2receive4dragon)
        # 
    except:
        print("(STEP 8Z8/33) OF TEST5SHOOT2DRAGON4URI *** FAILED GETTING COMMUNICATION AND CONTROL MESSAGES FROM DRAGON PIPE ", time4xi())    

    #dynamic-start


    #dynamic-end    
                
   
    # ---------------------------------------------------------------------------------------------    
    # Print Trace
    # ---------------------------------------------------------------------------------------------     
    ack2trace = False
    if ack2trace is True:
        print ('(STEP 32A/33) OF TEST5SHOOT2DRAGON4URI - PRINTING TRACE WITH T2XI', t2xi) 
        # <print4xi.Print4Xi object at 0x029C5570>
    
        print_trace4xi(t2xi)        
        print ('(STEP 32B/33) OF TEST5SHOOT2DRAGON4URI - PRINTED TRACE WITH T2XI', t2xi)           
        # <print4xi.Print4Xi object at 0x029C5570>
    
    print ('(STEP 33/33) OF TEST5SHOOT2DRAGON4URI - COMPLETED ', time4xi())
    #  
    return
#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\shoot2dragon4uri5test.txt
# \web\xml\ace-shoot2dragon4uri5test.xml
# \web\xml\reason-shoot2dragon4uri5test.xml
# \web\xml\sense-shoot2dragon4uri5test.xml
# 
#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2dragon4uri5test.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

